Package org.apache.commons.collections4.bidimap

# Class AbstractOrderedBidiMapDecorator<K,V>

java.lang.Object
org.apache.commons.collections4.map.AbstractIterableMap<K,V>
org.apache.commons.collections4.map.AbstractMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractBidiMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractOrderedBidiMapDecorator<K,V>

Type Parameters:
  `K` - the type of the keys in this map
  `V` - the type of the values in this map

All Implemented Interfaces:
  `Map<K,V>`, `BidiMap<K,V>`, `Get<K,V>`, `IterableGet<K,V>`, `IterableMap<K,V>`, `OrderedBidiMap<K,V>`, `OrderedMap<K,V>`, `Put<K,V>`

Direct Known Subclasses:
  `AbstractSortedBidiMapDecorator`, `UnmodifiableOrderedBidiMap`

public abstract class AbstractOrderedBidiMapDecorator<K,V> extends AbstractBidiMapDecorator<K,V> implements OrderedBidiMap<K,V>
Provides a base decorator that enables additional functionality to be added to an OrderedBidiMap via decoration.

Methods are forwarded directly to the decorated map.

This implementation does not perform any special processing with the map views. Instead it simply returns the inverse from the wrapped map. This may be undesirable, for example if you are trying to write a validating implementation it would provide a loophole around the validation. But, you might want that loophole, so this class is kept simple.

Since:
  3.0

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K,V>`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractOrderedBidiMapDecorator(OrderedBidiMap<K,V> map)`
  Constructor that wraps (not copies).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected OrderedBidiMap<K,V>`
  `decorated()`
  Gets the map being decorated.
  `K`
  `firstKey()`
  Gets the first key currently in this map.
  `OrderedBidiMap<V,K>`
  `inverseBidiMap()`
  Gets a view of this map where the keys and values are reversed.
  `K`
  `lastKey()`
  Gets the last key currently in this map.
  `OrderedMapIterator<K,V>`
  `mapIterator()`
  Obtains a `MapIterator` over the map.
  `K`
  `nextKey(K key)`
  Gets the next key after the one specified.
  `K`
  `previousKey(K key)`
  Gets the previous key before the one specified.

  ### Methods inherited from class org.apache.commons.collections4.bidimap.AbstractBidiMapDecorator

  `getKey, removeValue, values`

  ### Methods inherited from class org.apache.commons.collections4.map.AbstractMapDecorator

  `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.collections4.BidiMap

  `getKey, put, removeValue, values`

  ### Methods inherited from interface org.apache.commons.collections4.Get

  `containsKey, containsValue, entrySet, get, isEmpty, keySet, remove, size, values`

  ### Methods inherited from interface java.util.Map

  `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, equals, forEach, get, getOrDefault, hashCode, isEmpty, keySet, merge, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size`

  ### Methods inherited from interface org.apache.commons.collections4.Put

  `clear, put, putAll`

- ## Constructor Details

  - ### AbstractOrderedBidiMapDecorator

    protected AbstractOrderedBidiMapDecorator(OrderedBidiMap<K,V> map)
    Constructor that wraps (not copies).
    Parameters:
      `map` - the map to decorate, must not be null
    Throws:
      `NullPointerException` - if the collection is null

- ## Method Details

  - ### decorated

    protected OrderedBidiMap<K,V> decorated()
    Gets the map being decorated.
    Overrides:
      `decorated` in class `AbstractBidiMapDecorator<K,V>`
    Returns:
      the decorated map

  - ### firstKey

    public K firstKey()
    Description copied from interface: `OrderedMap`
    Gets the first key currently in this map.
    Specified by:
      `firstKey` in interface `OrderedMap<K,V>`
    Returns:
      the first key currently in this map

  - ### inverseBidiMap

    public OrderedBidiMap<V,K> inverseBidiMap()
    Description copied from interface: `BidiMap`
    Gets a view of this map where the keys and values are reversed.

    Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `Map`.

    Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

    Specified by:
      `inverseBidiMap` in interface `BidiMap<K,V>`
    Specified by:
      `inverseBidiMap` in interface `OrderedBidiMap<K,V>`
    Overrides:
      `inverseBidiMap` in class `AbstractBidiMapDecorator<K,V>`
    Returns:
      an inverted bidirectional map

  - ### lastKey

    public K lastKey()
    Description copied from interface: `OrderedMap`
    Gets the last key currently in this map.
    Specified by:
      `lastKey` in interface `OrderedMap<K,V>`
    Returns:
      the last key currently in this map

  - ### mapIterator

    public OrderedMapIterator<K,V> mapIterator()
    Description copied from class: `AbstractIterableMap`
    Obtains a `MapIterator` over the map.

    A map iterator is an efficient way of iterating over maps. There is no need to access the entry set or use Map Entry objects.

         IterableMap<String,Integer> map = new HashedMap<String,Integer>();
         MapIterator<String,Integer> it = map.mapIterator();
         while (it.hasNext()) {
           String key = it.next();
           Integer value = it.getValue();
           it.setValue(value + 1);
         }

    Specified by:
      `mapIterator` in interface `IterableGet<K,V>`
    Specified by:
      `mapIterator` in interface `OrderedMap<K,V>`
    Overrides:
      `mapIterator` in class `AbstractBidiMapDecorator<K,V>`
    Returns:
      a map iterator

  - ### nextKey

    public K nextKey(K key)
    Description copied from interface: `OrderedMap`
    Gets the next key after the one specified.
    Specified by:
      `nextKey` in interface `OrderedMap<K,V>`
    Parameters:
      `key` - the key to search for next from
    Returns:
      the next key, null if no match or at end

  - ### previousKey

    public K previousKey(K key)
    Description copied from interface: `OrderedMap`
    Gets the previous key before the one specified.
    Specified by:
      `previousKey` in interface `OrderedMap<K,V>`
    Parameters:
      `key` - the key to search for previous from
    Returns:
      the previous key, null if no match or at start